/* Tabela INCIDENCIA: Incidncia */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INCIDENCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Incidncia,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_INCIDENCIA
AFTER DELETE OR INSERT OR UPDATE
ON INCIDENCIA FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_CDARVPROD    VARCHAR2(20);
  V1_CDARVPROD   VARCHAR2(20);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         SELECT MAX(CDARVPROD) INTO V_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :OLD.CDPRODUTO;
         IF V_CDARVPROD IS NOT NULL THEN
           V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      END IF;

      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empr=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta=' || :OLD.CDINSCESTA;
      END IF;

      IF :OLD.IDENTRSAIDIN  IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :OLD.IDENTRSAIDIN ;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Impo=' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.CDFISCAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFisc=' || :OLD.CDFISCAL;
      END IF;

      IF :OLD.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupFisc=' || :OLD.CDGRUPOFISC;
      END IF;

      IF :OLD.IDINCINTEREST IS NOT NULL THEN
         V_DESC := V_DESC || ' OperIntEst=' || :OLD.IDINCINTEREST;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.NRINCIDENCIA;
   ELSE
      IF UPDATING THEN
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO; 
         IF (:NEW.CDPRODUTO     <> :OLD.CDPRODUTO)    OR
            (:NEW.CDEMPRESA     <> :OLD.CDEMPRESA)    OR
            (:NEW.CDINSCESTA    <> :OLD.CDINSCESTA)   OR
            (:NEW.IDENTRSAIDIN   <> :OLD.IDENTRSAIDIN ) OR
            (:NEW.CDTIPOOPER    <> :OLD.CDTIPOOPER)   OR
            (:NEW.CDIMPOSTO     <> :OLD.CDIMPOSTO)    OR
            (:NEW.CDFISCAL      <> :OLD.CDFISCAL)     OR
            (:NEW.CDGRUPOFISC   <> :OLD.CDGRUPOFISC)  OR
            (:NEW.IDINCINTEREST <> :OLD.IDINCINTEREST)THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.NRINCIDENCIA;
         END IF;
      ELSE
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO; 
         V_TIPO   := '1';
         V_ITPESQ := :NEW.NRINCIDENCIA;
      END IF;

      IF V1_CDARVPROD IS NOT NULL THEN
         V_DESC := V_DESC || ' Prod=' || V1_CDARVPROD;
      END IF;

      IF :NEW.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empr=' || :NEW.CDEMPRESA;
      END IF;

      IF :NEW.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta=' || :NEW.CDINSCESTA;
      END IF;

      IF :NEW.IDENTRSAIDIN  IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTRSAIDIN ;
      END IF;

      IF :NEW.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :NEW.CDTIPOOPER;
      END IF;

      IF :NEW.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Impo=' || :NEW.CDIMPOSTO;
      END IF;

      IF :NEW.CDFISCAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFisc=' || :NEW.CDFISCAL;
      END IF;

      IF :NEW.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupFisc=' || :NEW.CDGRUPOFISC;
      END IF;

      IF :NEW.IDINCINTEREST IS NOT NULL THEN
         V_DESC := V_DESC || ' OperIntEst=' || :NEW.IDINCINTEREST;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('INCIDENCIA',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_INCIDENCIA','5.20.000'); END;
/
